﻿Imports System.IO
Imports System.Globalization
Public Class ImageConverter
    Implements IValueConverter
    Public Function Convert(ByVal value As Object, _
                            ByVal targetType As Type, _
                            ByVal parameter As Object, _
                            ByVal culture As CultureInfo) _
                            As Object Implements IValueConverter.Convert
        Dim BmpImage As BitmapSource
        Dim BmpBytes = DirectCast(value, System.Data.Linq.Binary).ToArray
        Using BmpStream = New MemoryStream()

            Dim NwOffset = 78 'para tratar imagens do tipo ole armazenadas no Northwind 
            BmpStream.Write(BmpBytes, NwOffset, BmpBytes.Length - NwOffset)
            BmpImage = BitmapFrame.Create(BmpStream, _
                                          BitmapCreateOptions.IgnoreImageCache, _
                                          BitmapCacheOption.OnLoad)
        End Using
        Return BmpImage
    End Function
    Public Function ConvertBack(ByVal value As Object, _
                           ByVal targetType As Type, _
                           ByVal parameter As Object, _
                           ByVal culture As CultureInfo) _
                           As Object Implements IValueConverter.ConvertBack
        Return Nothing
    End Function
End Class